#!/usr/bin/sh

# Copyright (c) 2020, Mellanox Technologies
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are those
# of the authors and should not be interpreted as representing official policies,
# either expressed or implied, of the FreeBSD Project.

usage () {
    cat >&2 <<EOF
usage: bfhcafw [-h|--help]
       bfhcafw find
       bfhcafw flint <FLINT ARGS...>
       bfhcafw mcra <MCRA ARGS...>
       bfhcafw bus

Various utilities for ConnectX interface on BlueField systems. Supports the
following commands:

find    Searches the filesystem for the correct ConnectX firmware image for
        the current system and prints the full path to it.

flint   Automatically selects the correct flint binary, and passes in the PCI
        device path for the ConnectX interface.

        bfhcafw flint query

        is equivalent to:

        (mst)flint -d <BF1 or BF2 PCI path> query

mcra    Similar to flint, automatically selects binary and PCI conf path to
        run mcra.

bus     Prints the PCI bus number for the ConnectX interface.

Set the environment variable VERBOSE=1 to see more detailed output.
EOF
}

err () {
    echo "bfhcafw: $@" >&2
}

debug () {
    if [ -n "$VERBOSE" ]; then
        echo "bfhcafw: debug: $@" >&2
    fi
}

BASE_FW_NAME=mlxfwmanager_sriov_dis_aarch64

get_chipnum () {
    if ! [ -e /sys/firmware/acpi/tables ]; then
        err "fatal: cannot find acpi tables"
        exit 1
    fi

    # Figure out which rev by searching for an ACPI table specific to the BF version
    if strings /sys/firmware/acpi/tables/SSDT* | grep -q MLNXBF02; then
        # BF1
        chipnum=41682
    elif strings /sys/firmware/acpi/tables/SSDT* | grep -q MLNXBF22; then
        # BF2
        chipnum=41686
    elif strings /sys/firmware/acpi/tables/SSDT* | grep -q MLNXBF33; then
        # BF3
        chipnum=41692
    fi

    echo $chipnum
}

# Get the mlxfw filename based on current system and a specified base name
# and separator.
get_mlxfw_name () {
    # $1 - Base filename
    # $2 - Separator

    echo "$1$2$(get_chipnum)"
}

# Search for FW file of a given filename in known locations
find_fw_with_name () {
    # $1 - FW updater filename

    # Ubuntu location
    mlxfw="/opt/mellanox/mlnx-fw-updater/firmware/$1"
    debug "searching $mlxfw"
    if [ -f $mlxfw ]; then echo $mlxfw; return 0; fi

    # Yocto location
    mlxfw="/lib/firmware/mellanox/$1"
    debug "searching $mlxfw"
    if [ -f $mlxfw ]; then echo $mlxfw; return 0; fi

    return 1
}

# Search for FW file with given basename, automatically adding the chip number
# based on current hardware.
find_fw_with_basename () {
    # $1 - FW Base name

    result=$(find_fw_with_name $(get_mlxfw_name "$1" -))
    if [ $? -eq 0 ]; then echo $result; return 0; fi

    # Need to try with _ as separator too, some older distributions use
    # _ instead of -
    result=$(find_fw_with_name $(get_mlxfw_name "$1" _))
    if [ $? -eq 0 ]; then echo $result; return 0; fi

    return 1
}

find_fw () {
    m_uid=$(id -u)

    if [ "$m_uid" -ne 0 ]; then
        err "fatal: must be root to find firmware"
        exit 1
    fi

    # First search using new filename, with the _fw suffix.
    fw_path="$(find_fw_with_basename ${BASE_FW_NAME}_fw)"
    if [ $? -eq 0 ]; then echo $fw_path; return 0; fi

    # If that doesn't work, search for the old filename
    fw_path="$(find_fw_with_basename $BASE_FW_NAME)"
    if [ $? -eq 0 ]; then echo $fw_path; return 0; fi

    # Very old software that only supports BF1 does not specify chip number,
    # instead just using the base name directly.
    err "warn: falling back to legacy FW filename"
    fw_path="$(find_fw_with_name $BASE_FW_NAME)"
    if [ $? -eq 0 ]; then echo $fw_path; return 0; fi

    return 1
}

find_flint () {
    if command -v flint >/dev/null; then
        echo flint
    elif command -v mstflint >/dev/null; then
        echo mstflint
    else
        err "err: cannot find flint executable"
        exit 1
    fi
}

find_mcra () {
    if command -v mcra >/dev/null; then
        echo mcra
    elif command -v mstmcra >/dev/null; then
        echo mstmcra
    else
        err "err: cannot find mcra executable"
        exit 1
    fi
}

get_pci_path () {
    pci_path="$(lspci | grep '00\.0.*BlueField.*ConnectX' | cut -f1 -d' ')"

    if [ -z "$pci_path" ]; then
        err "err: cannot get PCI path in livefish mode"
        exit 1
    fi

    echo $pci_path
}

run_flint () {
    $(find_flint) -d $(get_pci_path) $@
}

run_mcra () {
    $(find_mcra) $(get_pci_path) $@
}

if [ "$1" = "-h" ] || [ "$1" = "--help" ]; then
    usage
    exit 0
fi

if [ "$1" = "find" ]; then 
    fw_path=$(find_fw)
    if [ $? -eq 0 ]; then
        echo "$fw_path"
        exit 0
    else
        err "err: the firmware package could not be located"
        exit 1
    fi
elif [ "$1" = "flint" ]; then
    shift
    run_flint $@
elif [ "$1" = "mcra" ]; then
    shift
    run_mcra $@
elif [ "$1" = "bus" ]; then
    shift
    echo $(get_pci_path)
else
    err "err: unknown cmd"
    usage
    exit 1
fi
